/****************************************************************
Copyright (c) 1998 Sandro Sigala <ssigala@globalnet.it>.
All rights reserved.

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name of the author not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

The author disclaim all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall the author be liable for any
special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
****************************************************************/

#ifndef MIRRORWIDGET_H
#define MIRRORWIDGET_H

#include <tqframe.h>

#include "ksmiletris.h"

class MirrorWidget : public TQFrame {
public:
	MirrorWidget(TQPixmap *s, bool *game, bool *pause,
		     TQWidget *parent=0, const char *name=0);

	void setBackgroundSprite(Sprite s) { bg_sprite = s; }
	void setMirrorSprites(Sprite *s) { mirror_sprites = s; }

private:
	TQPixmap *sprites;
	bool *in_game, *in_pause;
	Sprite bg_sprite;
	Sprite *mirror_sprites;

protected:
	void drawContents(TQPainter *p);
};

#endif // !MIRRORWIDGET_H
